//
//  ViewController.m
//  HelloAqTk
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    // AquesTalkインスタンス生成
    m_pAqTk = AquesTalkDa_Create();
   
 //   int iret1= AquesTalk_SetDevKey("XXX-XXX-XXX"); // 開発ライセンスキー
 //   int iret2= AquesTalk_SetUsrKey("ZZZ-ZZZ-ZZZ"); // 使用ライセンスキー

    // Notificationの登録　発声終了を検知しなければ不要 メソッド名やnameは任意で
    [[NSNotificationCenter defaultCenter]
     addObserver:self
     selector:@selector(daDone:)
     name: @"AquesTalkDaDoneNotify"
     object:nil];
}

- (void)dealloc {
    if(m_pAqTk) AquesTalkDa_Release(m_pAqTk);
    [[NSNotificationCenter defaultCenter] removeObserver:self];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(IBAction)play:(id)sender
{
    //終了通知イベントの作成　name部分はNSNotificationCenterに設定した値に合わせる
    NSNotification *notification = [NSNotification notificationWithName:@"AquesTalkDaDoneNotify" object:self userInfo:nil];

    // テキストボックスから文字列取得し、文字コードをShiftJISに変換
    char *sjis = (char*)[[textfield text] cStringUsingEncoding:NSShiftJISStringEncoding];

    // 声質設定
    AQTK_VOICE voice =gVoice_F1; //プリセット声種のF1をベースにする
    voice.spd = (int)[spd value]; // スライダーの値から話速をセット
    voice.pit = (int)[pit value]; // 高さ
    voice.lmd = (int)[lmd value]; // 音程1

    // 音声合成　非同期再生
    int iret = AquesTalkDa_Play(m_pAqTk, &voice, sjis, notification);

    if(iret!=0){ // エラーの場合はアラート表示
        UIAlertController *alertController = [UIAlertController alertControllerWithTitle:@"Error" message:@"音声記号列の指定が正しくありません" preferredStyle:UIAlertControllerStyleAlert];
        [alertController addAction:[UIAlertAction actionWithTitle:@"はい" style:UIAlertActionStyleDefault handler:^(UIAlertAction *action) { }]];
        [self presentViewController:alertController animated:YES completion:nil];
        return;
    }
    onPlayLabel.text = @"Playing...";
}

-(IBAction)stop:(id)sender
{
    AquesTalkDa_Stop(m_pAqTk);
}

- (void)daDone:(NSNotification*)notification
{
    onPlayLabel.text = @"Done";
}

// キーボードの[完了]押下で呼ばれる
- (IBAction)getText:(id)sender {
    [sender resignFirstResponder];//キーボードを隠す
    [self play:sender];//playボタン押したのと同じ
}


@end
