//
//  ViewController.swift
//  HelloAqTk
//

import UIKit

class ViewController: UIViewController {

    @IBOutlet weak var textField: UITextField!
    @IBOutlet weak var status: UILabel!
    @IBOutlet weak var spd: UISlider!
    @IBOutlet weak var pit: UISlider!
    @IBOutlet weak var lmd: UISlider!

    var m_pAqTk: H_AQTKDA?    //AquesTalkエンジンのインスタンス
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
        // AquesTalkインスタンス生成
        m_pAqTk = AquesTalkDa_Create();
    }
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        // Notificationの登録　発声終了を検知しなければ不要 メソッド名やnameは任意で
        NotificationCenter.default.addObserver(self, selector: #selector(ViewController.daDone(_:)), name: Notification.Name("AquesTalkDaDoneNotify"), object: nil)
    }
    deinit {
        AquesTalkDa_Release(m_pAqTk)
    }
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    @IBAction func play(_ sender: Any) {
        //終了通知イベントの作成　name部分はNSNotificationCenterに登録した値に合わせる
        let myNotifi: Notification = Notification(name: Notification.Name("AquesTalkDaDoneNotify"), object: self, userInfo: nil)

        // テキストボックスの文字列からCの文字列(文字コードはUtf8)を取得する（もっとスマートな方法は？）
        let str_utf8 = textField.text._bridgeToObjectiveC().utf8String
 
        // 声質設定　値の範囲はAquesTalk_iPhone.h参照
        var voice: AQTK_VOICE
        voice = gVoice_F1
        voice.spd = Int32(spd.value)    // 50-300
        voice.pit = Int32(pit.value)    // 20-200
        voice.lmd = Int32(lmd.value)    // 0-200

        // 音声合成　非同期再生
        let iret = AquesTalkDa_Play_Utf8(m_pAqTk, &voice, str_utf8!, myNotifi)
        if(iret != 0){
            let alert = UIAlertController(title: "Err", message: "音声記号烈が正しくありません", preferredStyle: .alert)
            alert.addAction(UIAlertAction(title: "OK", style: .default))
            self.present(alert, animated: true, completion: nil)
        }
        status.text = "playing..."
    }

    @IBAction func stop(_ sender: Any) {
        AquesTalkDa_Stop(m_pAqTk)
    }

    // 発声終了後に呼ばれる
    @objc func daDone(_ notification: Notification) {
        status.text = "Done"
    }
    
}

